<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-button
        size="mini"
        type="primary"
        @click="handleAdd"
        v-hasPermi="['system:startWork:edit']"
        v-if="this.consList.length === 0"
        style="float:right;margin-right: 10px;font-size: 18px"
      >提交申请
      </el-button>
    </el-form>

    <el-table v-loading="loading" :data="consList" @selection-change="handleSelectionChange" style="margin-top: 20px;">
      <el-table-column
        type="index"
        width="55"
        label="序号"
        align="center"
        :index="indexContinuous(queryParams.pageNum, queryParams.pageSize)"
      />
      <el-table-column label="工程名称" align="center" prop="proName" />
      <el-table-column label="承包商名称" align="center" prop="contName" />
      <el-table-column label="申请时间" align="center" prop="startDate" />
      <el-table-column label="审批状态" align="center" prop="intoStatus" >
        <template slot-scope="scope">
          <!-- 检查是否存在身份证号 -->
          <span v-if="scope.row.intoStatus">{{ updateStatus(scope.row.intoStatus)
            }}</span>
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            @click="handleRevocation(scope.row)"
            v-if="scope.row.intoStatus == '1'"
            v-hasPermi="['system:startWork:edit']"
          >撤回
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleView(scope.row)"
            v-else-if="scope.row.intoStatus == '2' || scope.row.intoStatus == '3'"
            v-hasPermi="['system:startWork:edit']"
          >查看
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleEdit(scope.row)"
            v-else-if="scope.row.intoStatus == '0' || scope.row.intoStatus == '4' || scope.row.intoStatus == '5'"
            v-hasPermi="['system:startWork:edit']"
          >编辑
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="submitApproval(scope.row)"
            v-if="scope.row.intoStatus == '8'"
            v-hasPermi="['system:consMaterial:edit']"
          >提交审核
          </el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleAuditRecord(scope.row)"
            v-hasPermi="['system:audit:query']"
          >审核记录
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
  </div>
</template>

<script>
import { dictTableOption, getProName } from '@/api/tool/select'
import { listCommencementApproval } from '@/api/pro/cons/equip'
import { retractApproval } from '@/api/terminalEquipment/deviceInformation'
import { encryptCBC } from '@/utils/aescbc'
import { submitApproval } from '@/api/pro/admissionRequest'
import { getParams, indexContinuous } from '@/utils/bonus'

export default {
  name: 'Post',
  data() {
    return {
      // 遮罩层
      loading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      proNameDict: [],
      // 工程表格数据
      consList: [],
      //审批类型下拉选
      statusDict: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        status: undefined
      },
      auditStatusDict:{
        "1" : "待审批",
        "2" : "审批中",
        "3" : "已通过",
        "4" : "已驳回",
        "5" : "已撤销"
      }
    }
  },
  created() {
    this.getList()
    this.getStatus()
  },
  methods: {
    indexContinuous,
    updateStatus(status){
      return this.auditStatusDict[status]
    },
    /** 查询开工审批列表 */
    getList() {
      this.loading = true
      this.queryParams.proId = this.$store.state.user.thisIds.proId
      this.queryParams.supUuid = this.$store.state.user.thisIds.supUuid
      this.queryParams.userType = this.$store.state.user.userType
      listCommencementApproval(this.queryParams).then(response => {
        this.consList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    //获取审批类型下拉选
    getStatus() {
      const params = {
        dictType: 'sys_approval_state',
        dictValue: ''
      }
      dictTableOption(params).then(response => {
        this.statusDict = response.data
      })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.subForm = {
        subName: undefined,
        address: undefined,
        corporateName: undefined,
        corporatePhone: undefined,
        socialUnifiedCreditCode: undefined,
        subPrincipal: undefined,
        subPrincipalPhone: undefined
      }
      this.resetForm('subForm')
      this.subOpen = false
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.proId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 提交申请按钮操作 */
    handleAdd(row) {
      this.$router.push("/pro/apply/consStartWorkApply/" + encryptCBC(JSON.stringify({
        uuid: row.uuid,
        proId: row.proId,
        consUuid: row.consUuid,
        supUuid: row.supUuid,
        taskId: row.taskId,
        procInstId:row.procInsId,
        finalCheck: row.finalCheck,
        disabled: false,
        type: 'add'
      })));
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.$router.push("/pro/apply/consStartWorkApply/" + encryptCBC(JSON.stringify({
        uuid: row.uuid,
        proId: row.proId,
        consUuid: row.consUuid,
        supUuid: row.supUuid,
        taskId: row.taskId,
        procInstId:row.procInsId,
        finalCheck: row.finalCheck,
        disabled: true,
        type: 'view'
      })));
    },
    /** 编辑按钮操作 */
    handleEdit(row) {
      this.$router.push("/pro/apply/consStartWorkApply/" + encryptCBC(JSON.stringify({
        uuid: row.uuid,
        proId: row.proId,
        consUuid: row.consUuid,
        supUuid: row.supUuid,
        taskId: row.taskId,
        procInstId:row.procInsId,
        finalCheck: row.finalCheck,
        disabled: false,
        type: 'edit'
      })));
    },
    /** 撤回按钮操作 */
    handleRevocation(row) {
      const params = {
        uuid: row.uuid,
        taskId: row.taskId,
        procInstId: row.procInsId,
        taskType: '4'
      }
      let text = '是否撤回当前开工申请的数据项？'
      this.$modal.confirm(text).then(function() {
        return retractApproval(params)
      }).then(() => {
        this.getList()
        this.$modal.msgSuccess('撤回成功')
      }).catch(() => {
      })
    },
    /** 审核记录按钮操作 */
    handleAuditRecord(row) {
      this.$router.push("/flow/auditRecord/" + encryptCBC(JSON.stringify({
        taskId: row.taskId,
        checkType:'2'
      })));
    },
    getParams,
    submitApproval(row){
      const param = {
        ...this.getParams(),
        taskType: '4',
        taskId: row.taskId,
        uuid: row.uuid,
      }
      submitApproval(param).then(response => {
        console.log("response="+JSON.stringify(response))
        if (response.code === 200) {
          if (response.msg === '此审核类型未配置相对应的审核流，请联系管理员配置后再次提交'){
            this.$modal.msgError(response.msg)
          }else{
            this.$modal.msgSuccess('提交成功')
          }
          this.getList()
        } else {
          this.$message.error(response.msg)
          this.getList()
        }
      }).catch((error) =>{
        console.log("error="+JSON.stringify(error))
      })
    }
  }
}
</script>
